
CoCoA-5 - Bug #486

Warning about variable hiding another -- too zealous

20 Mar 2014 17:29 - John Abbott

Status: New Start date: 20 Mar 2014

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Parser/Interpreter Estimated time: 20.00 hours

Target version: CoCoA-5.?.? Spent time: 0.25 hour

Description

The warning are sometimes is needlessly alarmist:

Define F(L)

  A := [abs(L[I]+1) | I in 1..len(L)];

  I := 1;

  While A[I] < 2 Do I:=I+1 EndWhile;

  Return I;

EndDefine;  -- F

 

Theis produces a WARNING that the loop variable I bound inside [...] is hiding the main variable I (which is "created" only after the

loop has finished).

Can we avoid these incorrect warnings?

Related issues:

Related to CoCoA-5 - Support #692: Local variables hiding out ones at top level Rejected 04 May 2015

History

#1 - 20 Mar 2014 17:34 - John Abbott

How to determine the "scope" of a variable?

A function comprises a sequential succession of "top-level" commands; the scope is from the first sequential step where it appears onward to the end

of the func.

NOTE a "sequential step" could be a loop, so the scope of a variable may start before the first occurrence in the source code.

#2 - 02 Apr 2014 17:34 - Anna Maria Bigatti

- Target version set to CoCoA-5.1.0 Easter14

#3 - 09 Apr 2014 17:30 - John Abbott

- Target version changed from CoCoA-5.1.0 Easter14 to CoCoA-5.1.1 Seoul14

#4 - 01 Sep 2014 13:55 - John Abbott

- Target version changed from CoCoA-5.1.1 Seoul14 to CoCoA-5.?.?

- Estimated time set to 20.00 h
